Bug 42572 - rusers shows users that are not logged in
rusers shows users that are not logged in
Product: Red Hat Linux
Classification: Retired
Component: rusers (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Phil Knirsch
David Lawrence
: 42890 (view as bug list)
Depends On:
  Show dependency treegraph
Reported: 2001-05-28 10:38 EDT by jmbastia
Modified: 2015-03-04 20:09 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2004-01-12 06:51:07 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description jmbastia 2001-05-28 10:38:10 EDT
From Bugzilla Helper:
User-Agent: Mozilla/4.76 [en] (X11; U; Linux 2.4.2-2 i686)

Description of problem:
When I run 'rusers' against a lab full of computers, it shows users that
are not actually logged in.  They _were_ logged in at one point, but have
since logged out, and 'rusers' is showing stale data.

'rusers' isn't the only command affected - 'who', 'finger', and 'last' all
show the same stale data.

The only command that accurately shows who is logged in is 'w'.

How reproducible:

Steps to Reproduce:
1. Just run the 'rusers', 'who', 'last | grep userid', or 'finger
@hostname' and the stale data is shown.

Actual Results:  For example, here is a screenshot of shelly.csl.mtu.edu
demonstrating the problem:

[jmbastia@astra ~]$ rusers shelly
shelly.csl.mtu.edu   ztan
[jmbastia@astra ~]$ rlogin shelly
Last login: Sat May 26 10:48:40 from astra.cs.mtu.edu
You have mail.
[jmbastia@shelly ~]$ who
jmbastia pts/0    May 28 10:15
ztan     pts/2    May 27 21:01
[jmbastia@shelly ~]$ finger @shelly
Login     Name                 Tty      Idle  Login Time   Office    
Office Phone
jmbastia  Jeffrey M. Bastian   pts/0          May 28 10:15
ztan      Zheng Tan           *pts/2    147d  May 27 21:01
[jmbastia@shelly ~]$ last | grep ztan | grep still
ztan     pts/2                         Sun May 27 21:01   still logged in
[jmbastia@shelly ~]$ w
 10:15am  up 20:00,  2 users,  load average: 0.00, 0.00, 0.00
USER     TTY      FROM              LOGIN@   IDLE   JCPU   PCPU  WHAT
jmbastia pts/0    astra.cs.mtu.edu 10:15am  0.00s  0.08s  0.01s  w 
[jmbastia@shelly ~]$ ps aux | grep ztan
jmbastia  3799  0.0  0.4  1620  592 pts/0    S    10:15   0:00 grep ztan

Expected Results:  ztan should not have been listed in any of the above
output.  The only correct output was from the 'w' command

Additional info:

I'm not sure if this is relevant, but in the changelog for kernel 2.4.5,
this is given for the pre2 release:

 - Alexander Viro: clean up process reaping procedures, make /proc use
   the proper fields to notice that the process is gone, gone, gone.
Comment 1 Phil Knirsch 2001-06-27 04:58:37 EDT
Using the most recent updates from rawhide i can't reproduce this problem.

I'll close the bug with RAWHIDE for now. If you could update your system with
the rawhide kernel/glibc and the newest rFOO tools (rsh, rusers etc.) and check
if the problem is actually gone i'd really appreciate it.


Read ya, Phil
Comment 2 Phil Knirsch 2001-06-27 07:31:31 EDT
*** Bug 42890 has been marked as a duplicate of this bug. ***
Comment 3 jmbastia 2002-05-28 14:24:43 EDT
This bug has resurfaced its ugly head in RedHat 7.3 (or maybe was never squashed

I notice that it only shows up for users who appear to have not logged out
correctly, which shows up in `last` as "gone - no logout".

  [jmbastia@consult ~]$ last | more
  jmbastia pts/1        astra            Tue May 28 14:18   still logged in   
  root     pts/1        astra            Tue May 28 13:20 - 13:21  (00:00)    
  hsuenaga pts/3                         Thu May 23 20:38 - 20:39  (00:01)    
  hsuenaga pts/2                         Thu May 23 16:48    gone - no logout

'hsuenaga' shows up as still logged in through rusers/finger/who.

Note that the 'w' command does show who is logged in correctly.
Comment 4 Phil Knirsch 2002-08-20 11:43:39 EDT
Yeah, seen that with the other tools as well. This seems to have been a kde bug
at some point and might be if connections are simply dropped and the wtmp/utmp
files don't get updated correctly.

One of the tools did it right, so i'll check that if i can find the difference
in how they 'login' status of a user is determined.

Read ya, Phil
Comment 5 Phil Knirsch 2004-01-12 06:51:07 EST
It seems as if the bug hasn't resurfaced, at least for me it works now
nicely again with RH 9, FC1 and RHEL3.

Closing the bug as works for me now.

Read ya, Phil

Note You need to log in before you can comment on or make changes to this bug.